/* A Bison parser, made from ../../../main/yacc/expr.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse expre_parse
#define yylex expre_lex
#define yyerror expre_error
#define yylval expre_lval
#define yychar expre_char
#define yydebug expre_debug
#define yynerrs expre_nerrs
# define	NUM	257
# define	LSH	258
# define	RSH	259
# define	LEQ	260
# define	GEQ	261
# define	EQ	262
# define	NEQ	263
# define	LAND	264
# define	LOR	265
# define	UPLUS	266
# define	UNEG	267

#line 2 "../../../main/yacc/expr.y"

#include <config.h>

#include <assert.h>
#include <errno.h>
#include <inttypes.h>  
#include <stdlib.h>
#include <string.h>

#include <expr.h>
#include <lib.h>
#include <port.h>

#include "../expr_code.h"
  
/* Parser information */
struct pi
{
  const char *expr; /* Current position in parsed expression */
  struct expr_code *start, *code, *end;
  unsigned flags; /* See EC_* in <expr.h> */
};

/* Semantic data type */
struct semantic
{
  /* In NUM, there was an error evaluating the port referece, so call YYABORT
     when possible */
  int err; 
};

#define YYSTYPE struct semantic

#define YYPARSE_PARAM pi_
#define YYLEX_PARAM pi_
#define YYERROR_VERBOSE
 
static void
expre_error (const char *s);
static int
expre_lex (YYSTYPE *lvalp, void *pi_);

/* Add OP to expression */
static void
expre_add_op (struct pi *pi, int op);
 
#ifndef YYSTYPE
# define YYSTYPE int
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 1
#endif



#define	YYFINAL		66
#define	YYFLAG		-32768
#define	YYNTBASE	29

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 267 ? yytranslate[x] : 43)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    26,     2,     2,     2,    23,    16,     2,
      27,    28,    21,    19,     2,    20,     2,    22,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    13,     2,
      17,     2,    18,    12,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    15,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    14,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    24,    25
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     6,     8,    11,    14,    17,    19,    23,
      27,    31,    33,    37,    41,    43,    47,    51,    53,    57,
      61,    65,    69,    71,    75,    79,    81,    85,    87,    91,
      93,    97,    99,   103,   105,   109,   111,   117
};
static const short yyrhs[] =
{
       3,     0,    27,    41,    28,     0,    29,     0,    19,    30,
       0,    20,    30,     0,    26,    30,     0,    30,     0,    31,
      21,    30,     0,    31,    22,    30,     0,    31,    23,    30,
       0,    31,     0,    32,    19,    31,     0,    32,    20,    31,
       0,    32,     0,    33,     4,    32,     0,    33,     5,    32,
       0,    33,     0,    34,    17,    33,     0,    34,    18,    33,
       0,    34,     6,    33,     0,    34,     7,    33,     0,    34,
       0,    35,     8,    34,     0,    35,     9,    34,     0,    35,
       0,    36,    16,    35,     0,    36,     0,    37,    15,    36,
       0,    37,     0,    38,    14,    37,     0,    38,     0,    39,
      10,    38,     0,    39,     0,    40,    11,    39,     0,    40,
       0,    40,    12,    41,    13,    41,     0,    41,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    82,    87,    90,    91,    92,   102,   117,   118,   131,
     149,   169,   170,   183,   198,   199,   212,   227,   228,   241,
     254,   267,   282,   283,   296,   311,   312,   327,   328,   343,
     344,   359,   360,   375,   376,   391,   392,   408
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "NUM", "\"<<\"", "\">>\"", "\"<=\"", 
  "\">=\"", "\"==\"", "\"!=\"", "\"&&\"", "\"||\"", "'?'", "':'", "'|'", 
  "'^'", "'&'", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "'%'", "UPLUS", 
  "UNEG", "'!'", "'('", "')'", "primary", "unary", "mult", "add", "shift", 
  "relation", "equal", "band", "bxor", "bor", "land", "lor", "cond", 
  "expression", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    29,    29,    30,    30,    30,    30,    31,    31,    31,
      31,    32,    32,    32,    33,    33,    33,    34,    34,    34,
      34,    34,    35,    35,    35,    36,    36,    37,    37,    38,
      38,    39,    39,    40,    40,    41,    41,    42
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     3,     1,     2,     2,     2,     1,     3,     3,
       3,     1,     3,     3,     1,     3,     3,     1,     3,     3,
       3,     3,     1,     3,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     3,     1,     5,     1
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     1,     0,     0,     0,     0,     3,     7,    11,    14,
      17,    22,    25,    27,    29,    31,    33,    35,    37,     4,
       5,     6,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     2,     8,     9,    10,    12,    13,    15,    16,
      20,    21,    18,    19,    23,    24,    26,    28,    30,    32,
      34,     0,     0,    36,     0,     0,     0
};

static const short yydefgoto[] =
{
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    64
};

static const short yypact[] =
{
      -2,-32768,    -2,    -2,    -2,    -2,-32768,-32768,    -1,    10,
      11,    -4,    23,   -12,    -3,     5,    25,    22,-32768,-32768,
  -32768,-32768,    17,    -2,    -2,    -2,    -2,    -2,    -2,    -2,
      -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,
      -2,    -2,-32768,-32768,-32768,-32768,    -1,    -1,    10,    10,
      11,    11,    11,    11,    -4,    -4,    23,   -12,    -3,     5,
      25,    24,    -2,-32768,    40,    46,-32768
};

static const short yypgoto[] =
{
  -32768,     3,    12,    13,   -22,     9,   -13,    14,    15,     8,
      16,-32768,    -5,-32768
};


#define	YYLAST		57


static const short yytable[] =
{
      22,     1,    30,    31,    36,    19,    20,    21,    50,    51,
      52,    53,    37,    32,    33,    28,    29,     2,     3,    38,
      23,    24,    25,    56,     4,     5,    43,    44,    45,    26,
      27,    34,    35,    40,    41,    39,    61,    62,    46,    47,
      65,    48,    49,    54,    55,    42,    66,    59,     0,     0,
       0,    57,     0,    58,     0,     0,    60,    63
};

static const short yycheck[] =
{
       5,     3,     6,     7,    16,     2,     3,     4,    30,    31,
      32,    33,    15,    17,    18,     4,     5,    19,    20,    14,
      21,    22,    23,    36,    26,    27,    23,    24,    25,    19,
      20,     8,     9,    11,    12,    10,    41,    13,    26,    27,
       0,    28,    29,    34,    35,    28,     0,    39,    -1,    -1,
      -1,    37,    -1,    38,    -1,    -1,    40,    62
};
#define YYPURE 1

/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 83 "../../../main/yacc/expr.y"
{ 
			  if (yyval.err != 0)
			    YYABORT;
			}
    break;
case 5:
#line 93 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c->code == E_VAL)
		    c->v.val = -c->v.val;
		  else
		    expre_add_op (pi_, E_NEG);
		}
    break;
case 6:
#line 103 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c->code == E_VAL)
		    c->v.val = !c->v.val;
		  else
		    expre_add_op (pi_, E_NOT);
		}
    break;
case 8:
#line 119 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val *= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_MUL);
		}
    break;
case 9:
#line 132 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      if (c->v.val == 0)
			{
			  expre_error ("division by zero");
			  YYABORT;
			}
		      c[-1].v.val /= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_DIV);
		}
    break;
case 10:
#line 150 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      if (c->v.val == 0)
			{
			  expre_error ("division by zero");
			  YYABORT;
			}
		      c[-1].v.val %= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_MOD);
		}
    break;
case 12:
#line 171 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val += c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_ADD);
		}
    break;
case 13:
#line 184 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val -= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_SUB);
		}
    break;
case 15:
#line 200 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val <<= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_LSH);
		}
    break;
case 16:
#line 213 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val >>= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_RSH);
		}
    break;
case 18:
#line 229 "../../../main/yacc/expr.y"
{
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val < c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_LT);
			}
    break;
case 19:
#line 242 "../../../main/yacc/expr.y"
{
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val > c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_GT);
			}
    break;
case 20:
#line 255 "../../../main/yacc/expr.y"
{
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val <= c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_LE);
			}
    break;
case 21:
#line 268 "../../../main/yacc/expr.y"
{
			  struct expr_code *c;
			  
			  c = ((struct pi *)pi_)->code - 1;
			  if (c[-1].code == E_VAL && c->code == E_VAL)
			    {
			      c[-1].v.val = c[-1].v.val >= c->v.val;
			      ((struct pi *)pi_)->code = c;
			    }
			  else
			    expre_add_op (pi_, E_GE);
			}
    break;
case 23:
#line 284 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val == c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		  expre_add_op (pi_, E_EQ);
		}
    break;
case 24:
#line 297 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val != c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_NE);
		}
    break;
case 26:
#line 313 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val &= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_BAND);
		}
    break;
case 28:
#line 329 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val ^= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_BXOR);
		}
    break;
case 30:
#line 345 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val |= c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_BOR);
		}
    break;
case 32:
#line 361 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val && c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_LAND);
		}
    break;
case 34:
#line 377 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 1;
		  if (c[-1].code == E_VAL && c->code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val || c->v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_LOR);
		}
    break;
case 36:
#line 393 "../../../main/yacc/expr.y"
{
		  struct expr_code *c;

		  c = ((struct pi *)pi_)->code - 2;
		  if (c[-1].code == E_VAL && c->code == E_VAL
		      && c[1].code == E_VAL)
		    {
		      c[-1].v.val = c[-1].v.val ? c->v.val : c[1].v.val;
		      ((struct pi *)pi_)->code = c;
		    }
		  else
		    expre_add_op (pi_, E_COND);
		}
    break;
case 37:
#line 409 "../../../main/yacc/expr.y"
{ expre_add_op (pi_, E_END); }
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 412 "../../../main/yacc/expr.y"


/* Add *CODE to expression */
static void
expre_add (struct pi *pi, const struct expr_code *code)
{
  if (pi->code == pi->end)
    {
      struct expr_code *copy;
      size_t size;

      size = 2 * (pi->end - pi->start);
      copy = xrealloc (pi->start, size * sizeof (*pi->start));
      pi->code = copy + (pi->code - pi->start);
      pi->end = copy + size;
      pi->start = copy;
    }
  *pi->code++ = *code;
}

/* Add OP to expression */
static void
expre_add_op (struct pi *pi, int op)
{
  struct expr_code code;

  code.code = op;
  expre_add (pi, &code);
}

static void
expre_error (const char *s)
{
  error (0, "%s", s);
}

/* Is C a hexadecimal digit? */
static int
is_hex_digit (char c)
{
  static const char valid[22] = "0123456789ABCDEFabcdef";

  return memchr (valid, c, sizeof (valid)) != NULL;
}

/* If we set lvalp->err = 1 in one of the parsing functions, we can leave
   pi->expr pointing anywhere, because as soon as we return to the parser,
   the parser aborts and pi->expr is not used again. */

/* Parse a character constant from PI to LVALP */
inline static void
parse_char_constant (YYSTYPE *lvalp, struct pi *pi)
{
  struct expr_code code;
  intmax_t val;
  char c;

  c = *pi->expr++;
  switch (c)
    {
    case '\'':
      expre_error ("empty character constant");
      lvalp->err = 1;
      return;

    case 0:
      goto unterminated;
      
    default:
      val = (unsigned char)c;
      break;

    case '\\':
      switch (*pi->expr++)
	{
	case '\'': case '\"': case '\?': case '\\':
	  val = (unsigned char)pi->expr[-1];
	  break;

	case 'a':
	  val = '\a';
	  break;

	case 'b':
	  val = '\b';
	  break;

	case 'f':
	  val = '\f';
	  break;

	case 'n':
	  val = '\n';
	  break;

	case 't':
	  val = '\t';
	  break;

	case 'r':
	  val = '\r';
	  break;

	case 'v':
	  val = '\v';
	  break;

	case '0': case '1': case '2': case '3': case '4': case '5': case '6':
	case '7':
	  val = pi->expr[-1] - '0';
	  if (*pi->expr >= '0' && *pi->expr < '8')
	    {
	      val = val * 8 + *pi->expr++ - '0';
	      if (*pi->expr >= '0' && *pi->expr < '8')
		val = val * 8 + *pi->expr++ - '0';
	    }
	  break;

	case 'x':
	  if (!is_hex_digit (*pi->expr))
	    goto bad_hex;
	  val = 0;
	  do
	    {
	      unsigned digit;
	      
	      switch (*pi->expr++)
		{
		case '0': case '1': case '2': case '3': case '4': case '5':
		case '6': case '7': case '8': case '9':
		  digit = pi->expr[-1] - '0';
		  break;

		case 'A': case 'a':
		  digit = 10;
		  break;
		case 'B': case 'b':
		  digit = 11;
		  break;
		case 'C': case 'c':
		  digit = 12;
		  break;
		case 'D': case 'd':
		  digit = 13;
		  break;
		case 'E': case 'e':
		  digit = 14;
		  break;
		case 'F': case 'f':
		  digit = 15;
		  break;

		default:
		  assert ("BUG" == NULL);
		  goto bad_hex;
		}
	      if (val > INTMAX_MAX / 16
		  || (val == INTMAX_MAX / 16 && digit > INTMAX_MAX % 16))
		goto bad_hex;
	      val = val * 16 + digit;
	    }
	  while (is_hex_digit (*pi->expr));
	  break;

	default:
	  expre_error ("invalid excape sequence");
	  lvalp->err = 1;
	  return;
	}
      break;
    }
  if (*pi->expr++ != '\'')
    goto unterminated;
  lvalp->err = 0;
  code.code = E_VAL;
  code.v.val = val;
  expre_add (pi, &code);
  return;

 bad_hex:
  expre_error ("invalid hexadecimal escape sequence");
  lvalp->err = 1;
  return;

 unterminated:
  expre_error ("unterminated character constant");
  lvalp->err = 1;
}

/* Parse a port value reference from PI to LVALP. In case this never gets
   documented ;-), the expected format is [PORT] or [c:PORT] if you want to
   reference the port in evaluate/modify, but don't want to assign to it. */
static void
parse_port (YYSTYPE *lvalp, struct pi *pi)
{
  struct expr_code code;
  char *end;
  size_t len;

  if (*pi->expr == 'c' && pi->expr[1] == ':')
    {
      pi->expr += 2;
      code.code = E_CPORT;
    }
  else
    code.code = E_PORT;
  /* FIXME: provide a way to define aliases */
  errno = 0;
  end = strchr (pi->expr, ']');
  if (end == NULL)
    {
      expre_error ("unterminated port reference");
      lvalp->err = 1;
      return;
    }
  len = end - pi->expr;
  {
    char copy[len + 1];
    struct port_id id;

    memcpy (copy, pi->expr, len);
    copy[len] = 0;
    code.v.port.width = get_port_width (port_find (NUM_WIDTHS, copy, &id));
    if (code.v.port.width == NUM_WIDTHS)
      {
	lvalp->err = 1;
	return;
      }
    switch (code.v.port.width)
      {
#define DO_TYPE(WIDTH, TYPE)						\
       case WIDTH_##WIDTH:						\
	{								\
	  TYPE val;							\
									\
	  if (((pi->flags & EC_MODIFY) == 0 || code.code == E_CPORT)	\
	      && port_disp_##WIDTH (&id, &val) != 0)			\
	    {								\
	      lvalp->err = 1;						\
	      return;							\
	    }								\
	  if ((pi->flags & EC_VALUE) == 0)				\
	    code.v.port.pi = id;					\
	  else								\
	    {								\
	      code.code = E_VAL;					\
	      code.v.val = val;						\
	    }								\
	  break;							\
	}
	DO_TYPE (1, int);
	DO_TYPE (8, uint8_t);
	DO_TYPE (16, uint16_t);

      default:
	assert ("BUG" == NULL);
#undef DO_TYPE
      }
  }
  pi->expr = end + 1;
  lvalp->err = 0;
  expre_add (pi, &code);
}

static int
expre_lex (YYSTYPE *lvalp, void *pi_)
{
  struct pi *pi;
  char c;

  pi = pi_;
  while ((c = *pi->expr++) != 0)
    {
      switch (c)
	{
	case ' ': case '\t': case '\n': case '\v': case '\f':
	  break; /* Ignore */

	case '0': case '1': case '2': case '3': case '4': case '5': case '6':
	case '7': case '8': case '9':
	  {
	    char *end;
	    struct expr_code code;

	    pi->expr--; /* Back to the first digit */
	    errno = 0;
	    code.v.val = strtoimax (pi->expr, &end, 0);
	    if (end == pi->expr || errno != 0)
	      {
		expre_error ("invalid integer constant");
		lvalp->err = 1;
		return NUM;
	      }
	    pi->expr = end;
	    lvalp->err = 0;
	    code.code = E_VAL;
	    expre_add (pi, &code);
	    return NUM;
	  }

	case '\'': /* L' ' not supported */
	  parse_char_constant (lvalp, pi);
	  return NUM;

	case '[':
	  parse_port (lvalp, pi);
	  return NUM;

#define CHECK(CHAR, SYM)			\
	  if (*pi->expr == CHAR)		\
	    {					\
	      pi->expr++;			\
	      return SYM;			\
	    }
	case '!':
	  CHECK ('=', NEQ);
	  return c;
	  
	case '&':
	  CHECK ('&', LAND);
	  return c;

	case '<':
	  CHECK ('<', LSH);
	  CHECK ('=', LEQ);
	  return c;

	case '=':
	  CHECK ('=', EQ);
	  return c;
	  
	case '>':
	  CHECK ('>', RSH);
	  CHECK ('=', GEQ);
	  return c;

	case '|':
	  CHECK ('|', LOR);
	  return c;
#undef CHECK
	  
	case 0: case '%': case '(': case ')': case '*': case '+': case '-':
	case '/': case ':': case '?': case '^': default:
	  return c;
	}
      
    }
  return 0;
}

/* Evaluate EXPR, store result to DEST;
   returns: 0 if OK, -1 on error */
int
expr_eval (const char *expr, intmax_t *dest)
{
  struct pi pi;
  int res;

  pi.expr = expr;
  pi.start = xmalloc (8 * sizeof (*pi.start));
  pi.code = pi.start;
  pi.end = pi.start + 8;
  pi.flags = EC_VALUE;
  if (expre_parse (&pi) != 0)
    {
      res = -1;
      goto err;
    }
  assert (pi.start->code == E_VAL && pi.start[1].code == E_END);
  *dest = pi.start->v.val;
  res = 0;
 err:
  free (pi.start);
  return res;
}

/* Compile EXPR according to FLAGS (see EC_* below);
   returns: expression (for free ()) if OK, NULL on error */
struct expr_code *
expr_compile (const char *expr, unsigned flags)
{
  struct pi pi;

  pi.expr = expr;
  pi.start = xmalloc (8 * sizeof (*pi.start));
  pi.code = pi.start;
  pi.end = pi.start + 8;
  pi.flags = flags;
  if (expre_parse (&pi) == 0)
    {
      pi.start = xrealloc (pi.start,
			   (pi.code - pi.start) * sizeof (*pi.start));
      return pi.start;
    }
  free (pi.start);
  return NULL;
}
