/* Item/Insert dialog -*-c++-*- */
#ifndef KHWINSERTDIALOG_H__
#define KHWINSERTDIALOG_H__

#include "khwinsertdialogbase.h"

class KHwInsertDialog: public KHwInsertDialogBase
{
  Q_OBJECT
public:
  KHwInsertDialog (QWidget *parent);
  ~KHwInsertDialog ();
  /** Get selected module type */
  QString getModuleType () const;
  /** Get selected module name */
  QString getModuleName () const;
  
protected slots:
  /** Module name or module type selection has changed */
  void nameOrTypeChanged ();
  /** Check if moduleName is OK, and accept () if so */
  void tryAccept ();
};

#endif
