/* xxmlMalloc () */
#include <config.h>

#include <errno.h>
#include <libxml/xmlmemory.h>

#include <lib.h>

/* xmlMalloc () SIZE bytes of memory, error () on failure;
   returns: pointer to allocated area */
void *
xxmlMalloc (size_t size)
{
  void *ptr;

  ptr = xmlMalloc (size);
  if (ptr != NULL || size == 0)
    return ptr;
  error (errno, "cannot allocate memory");
  exit (EXIT_FAILURE);
}
