#!/bin/sh

name="cereal"
title="cereal"
package="cereal"
version="0.93"
build="1.1"
noarch="n"
build_info="Standard build."

info="An easily-extensible 8051 emulator."
desc="cereal is an emulation framework able to emulate 8051-compatible
CPUs and connected devices, designed to allow easy addition of
other (application-specific) devices to emulate."
category="development/emulator"
environment="x11/qt"
contact="$name@packages.packware.one.pl"
vendor="The Packware Project"
vendor_id="pw"

requires=""
obsoletes=""
conflicts=""

docs_source="AUTHORS,COPYING,INSTALL,NEWS,README"
docs_cwd=""

strip_bin="y"
reset_own="y"
reset_dir="y"
reset_fil="y"
delete_cat="y"

. /usr/src/tgz/lib/builder.defs

add_source http://belnet.dl.sourceforge.net/sourceforge/cereal/$name-$version.tar.gz

configure_option --prefix=/opt/kde

install_option DESTDIR=$pkg_main

parent_package="$package"
write_info main

cd $src1

do_configure
do_make
do_install

make_docs

make_package main

clean_up

# $Log: cereal.builder,v $
# Revision 1.1  2003/02/10 12:57:57  swiergot
# - Initial release.
# - Version 0.93.
#
